<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->

<template>
  <div>
    <el-row>
      <el-form
        label-width="180px"
        :rules="rules"
        ref="currentData"
        class="demo-ruleForm"
        :model="currentData"
      >
        <span>Basic Information</span>
        <el-row>
          <el-col
            :span="6"
          >
            <el-form-item
              prop="envName"
              :label="$t('env.name')"
            >
              <el-input
                id="name"
                v-model="currentData.envName"
              />
            </el-form-item>
          </el-col>
          <el-col
            :span="6"
          >
            <el-form-item
              prop="envDescription"
              :label="$t('env.description')"
            >
              <el-input
                v-model="currentData.envDescription"
                id="description"
              />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col
            :span="12"
          >
            <el-form-item
              label-width="180px"
              prop="type"
              :label="$t('env.type')"
            >
              <el-radio-group
                v-model="currentData.type"
              >
                <el-radio label="PowerGrid" />
                <el-radio label="VR/AR" />
                <el-radio label="IoV" />
                <el-radio label="Enterprise" />
              </el-radio-group>
            </el-form-item>
          </el-col>
        </el-row>
        <span>Lab Information</span>
        <el-row>
          <el-col
            :span="6"
          >
            <el-form-item
              prop="lab"
              :label="$t('env.lab')"
            >
              <el-select
                id="lab"
                v-model="currentData.lab"
                default-first-option
                placeholder=""
                style="width:100%"
                @change="getResDataList"
              >
                <el-option
                  v-for="item in labs"
                  :key="item.labName"
                  :label="item.labName"
                  :value="item.labName"
                />
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-form-item
            prop="resources"
            :label="$t('env.specificationSection')"
          />
          <div class="tableDiv">
            <el-table
              :data="tableData"
              border
              @selection-change="handleSelectionChange"
            >
              <el-table-column
                type="selection"
                width="55"
              />
              <el-table-column
                prop="ipAddress"
                :label="$t('env.ipAddress')"
              />
              <el-table-column
                prop="nodeType"
                :label="$t('env.nodeType')"
              />
              <el-table-column
                prop="architacture"
                :label="$t('env.architacture')"
              />
              <el-table-column
                prop="specifications"
                :label="$t('env.specifications')"
              />
              <el-table-column
                prop="specialResources"
                :label="$t('env.specialResources')"
              />
            </el-table>
          </div>
        </el-row>
        <el-row>
          <el-col
            :span="6"
          >
            <el-form-item
              :label="$t('env.remark')"
            >
              <el-input
                type="textarea"
                v-model="currentData.remarks"
                :rows="3"
              />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col
            :span="6"
          >
            <el-button
              id="createBtn"
              type="primary"
              style="margin-left:180px;margin-bottom:20px;"
              @click="submitForm('currentData')"
            >
              <em class="el-icon-ok" />
              Create
            </el-button>
          </el-col>
        </el-row>
      </el-form>
    </el-row>
  </div>
</template>
<script>
import { BASE_URL } from '../tools/constant.js'
import axios from 'axios'
export default {
  name: 'Application',
  components: {
  },
  data () {
    return {
      labs: [],
      tableData: [],
      currentData: {
        resources: []
      },
      rules: {
        envName: [
          { required: true, message: 'Environment name can not be empty', trigger: 'blur' }
        ],
        envDescription: [
          { required: true, message: 'Environment description can not be empty', trigger: 'blur' }
        ],
        lab: [
          { required: true, message: 'Lab can not be empty', trigger: 'blur' }
        ],
        type: [
          { required: true, message: 'Type can not be empty', trigger: 'blur' }
        ],
        resources: [
          { required: true, message: 'Please select atleast one resource', trigger: 'blur' }
        ]
      }
    }
  },
  mounted () {
    this.getLabs()
  },
  computed: {
  },
  methods: {
    handleSelectionChange (val) {
      this.currentData.resources = val
    },
    submitForm (formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          this.addEnvData()
        } else {
          console.log('error submit!!')
          return false
        }
      })
    },
    async getResDataList (val) {
      let url = BASE_URL + '/getAvailableResources?lab=' + val
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.tableData = res.data
      }, error => {
        if (error) {
          this.$parent.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    async addEnvData () {
      this.currentData['userId'] = sessionStorage.getItem('userId')
      let url = BASE_URL + '/addEnvRequest'
      if (sessionStorage.getItem('role').toLowerCase() === 'administrator') {
        url = BASE_URL + '/addEnv'
      }
      axios({
        method: 'POST',
        url: url,
        data: this.currentData,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.currentData = {}
        this.tableData = []
        this.$refs['currentData'].resetFields()
        this.$emit('cancelDialog', true)
      }, error => {
        if (error) {
          this.$parent.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    async getLabs (data) {
      let url = BASE_URL + '/getLab'
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.labs = res.data
      }, error => {
        if (error) {
          this.$parent.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    }
  }
}
</script>
<style lang='less' scoped>
.tableDiv {
  width:60%;
  margin-left: 10%;
  margin-bottom: 1%;
}
</style>
